#!/bin/bash
#
# Script to copy a profil for a user
#
# Copyright (c) 2006 Peter Varkoly (peter@varkoly.de
#
OPTS=""

usage()
{
echo "

Usage: oss_copy_profil uid OS profil [ro]
	uid	UID of the user
	OS	The target operating system WinNT Win2K WinXP Win3K Linux
	profil  The name of the profil to be distributed
	ro	If this parameter set the profil is read only (mandatory)

Examples:

	oss_copy_profil bigboss WinXP tteachers

	oss_copy_profil minibos WinXP Default_User ro

"
}
if [ $# -lt 3 ]
then
  usage
  exit 1;
fi

if [ $2 = 'Linux' ]
then
   echo "TODO"
else
	PROFIL='/home/profile/'$1'/'$2

	if [ $3 = 'Default_User' ]
	then
	  TPROFIL='/var/lib/samba/netlogon/'$2'/Default User'
	else
	  TPROFIL="/home/profile/$3"
	fi
	if [ ! -e "$TPROFIL" ]
	then
	  echo "Profil path do not exists $TPROFIL"
	  exit
	fi

	test -e $PROFIL && rm -rf $PROFIL

	mkdir   -m 700 -p    $PROFIL
	chown    $1          $PROFIL
	setfacl -d -m o::rwx $PROFIL
	rsync   -a "$TPROFIL/"  $PROFIL'/'
	chown   -R $1        $PROFIL
	chmod   -R 700       $PROFIL
	if [ $4 = 'ro' ]
	then
	  mv      $PROFIL'/ntuser.dat' $PROFIL'/ntuser.man'
	fi  

fi
