#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Data::Dumper;
use oss_utils;
use oss;

my $oss = oss->new();
if( ! $oss->connect_ldap() )
{
  print $oss->{ERROR}->{text};
  exit 1;
}
$oss->init_sysconfig('file');
# If neccessary read the commandline options
while(my $param = shift)
{
  if( $param =~ /text/i ) { $oss->{XML}=0; }
}

my $mesg;
my $dn               = '';
my $IP               = '';
my $MAC              = '';
my $HOST_NAME        = '';

my $DEBUG               = 0;
if( $oss->get_school_config('SCHOOL_DEBUG') eq 'yes' )
{ 
  $DEBUG = 1;
}
open(OUT,">/tmp/get_user") if ($DEBUG);
while(<STDIN>)
{
  print OUT if ($DEBUG);
  # Clean up the line!
  chomp; s/^\s+//; s/\s+$//;

  my ( $key, $value ) = split / /,$_,2;
  if( !$value )
  {
	if( $key ne '' )
	{
		$dn = $key;
	}
  }
  elsif ( $key =~ /IP/i )
  {
	$IP = $value;
  }
  elsif ( $key =~ /MAC/i )
  {
	$MAC = $value;
  }
  elsif ( $key =~ /HOST_NAME/i )
  {
	$HOST_NAME = $value;
  }
}
#DEBUG
close OUT if ($DEBUG);


#-----------------------------------------------------------------------------
if( $IP eq '' && $MAC eq '' && $HOST_NAME eq '' )
{
  print $oss->reply($oss->get_rooms);
}
elsif( $IP ne '' )
{
  print $oss->reply($oss->get_room_of_ip($IP));
}
exit;
