#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Data::Dumper;
use oss_utils;
use oss;

#-----------------------------------------------------------------------------
# Initialisierung
#
# If neccessary read the commandline options
my $oss = oss->new();
while(my $param = shift) {
  if( $param =~ /text/i ) { $oss->{XML}=0; }
}
$oss->connect_ldap();

my $dn         = '';
my $base       = $oss->{LDAP_BASE};
my $scope      = 'one';
my $filter     = '';
my $nfilter    = 0;
my $mesg;
my @attributes = ();

while(<STDIN>)
{

  # Clean up the line!
  chomp; s/^\s+//; s/\s+$//;

  my ( $key, $value ) = split / /,$_,2;
  if( !$value )
  {
	chomp $key;
	if( $key =~ /^uniqueidentifier=.*/i )
        {
	   $dn = $key;
	}
  }
  elsif ( $key eq 'attributes' )
  {
        @attributes = split / /,$value;
  }
  elsif ( $key eq 'oid' )
  {
	$filter .= '(uniqueidentifier='.$value.')';
  }
  else 
  {
	$filter .= '('.$key.'='.$value.')';
  }
}

if( $dn ne '' )
{
	$filter = '(objectclass=School)';
	$scope  = 'base';
	$base   = $dn;
}
elsif ( $filter ne '' )
{
	$filter = '(&(objectclass=School)'.$filter.')';
}
else
{
	$filter = '(objectclass=School)';
}

if( scalar(@attributes) )
{
   $mesg = $oss->{LDAP}->search( 
                          base   => $base,
                          scope  => $scope,
                          filter => $filter,
                          attrs  => \@attributes
                        );
}
else
{
   $mesg = $oss->{LDAP}->search( 
                          base   => $base,
                          scope  => $scope,
                          filter => $filter
                        );
}

if( ! $mesg )
{
        print "ERROR Could not search the school\n";
        exit 1;
}

my $result = $mesg->as_struct;
foreach my $dn ( keys %{$result} )
{
  $oss->init_sysconfig($dn); 
  if( scalar(@attributes) )
  {
	foreach my $key (@attributes)
	{
	   if( $key =~ /^SCHOOL_/ )
	   {
	     push @{$result->{$dn}->{$key}}, $oss->{SYSCONFIG}->{$key};
	   }
	}
  }
  else
  {
	foreach my $key ( keys %{$oss->{SYSCONFIG}} )
	{
	   push @{$result->{$dn}->{$key}}, $oss->{SYSCONFIG}->{$key};
	}
  }
}
print $oss->reply($result);

