#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Net::LDAP;
use Net::LDAP::Entry;
use oss;
use oss_utils;
use Data::Dumper;

my @dns                = ();
my $configurationKey   = '';
my @configurationValue = ();
my $o                  = '';

# Make LDAP Connection
my $oss = oss->new();
$oss->connect_ldap();

while(<STDIN>)
{
	# Clean up the line!
	chomp; s/^\s+//; s/\s+$//;
	
	my ( $key, $value ) = split / /,$_,2;
	
	if( !defined $value  || $value eq  '' )
	{
	        chomp $key;
	        push @dns, $key;
	}
	elsif( $key =~ /configurationKey/i )
	{
	      $configurationKey = $value;
	}
	elsif( $key = /o/i )
	{
	      $o = $value;
	}
}

foreach my $dn (@dns)
{
	print $oss->reply($oss->get_vendor_object($dn,$o,$configurationKey));
}

$oss->destroy();
