#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Data::Dumper;
use oss_utils;
use oss;

# If neccessary read the commandline options
my $oss = oss->new();
# Initialisierung
#
if( ! $oss->connect_ldap() )
{
  print $oss->{ERROR}->{text};
  exit 1;
}
$oss->init_sysconfig('file');

while(my $param = shift)
{
  if( $param =~ /text/i ) { $oss->{XML}=0; }
}

my $mesg;
my $dn               = '';

my $DEBUG               = 0;
if( $oss->get_school_config('SCHOOL_DEBUG') eq 'yes' )
{ 
  $DEBUG = 1;
}

open(OUT,">/tmp/get_workstation") if ($DEBUG);
while(<STDIN>)
{
	print OUT if ($DEBUG);
	# Clean up the line!
	chomp; s/^\s+//; s/\s+$//;
	if( $_ ne '' )
	{
	    $dn = $_;
	}
}
close OUT if ($DEBUG);


#-----------------------------------------------------------------------------
print $oss->reply($oss->get_workstations($dn));

exit;
