#!/usr/bin/perl  -w
BEGIN{
    push @INC,"/srv/www/admin/lib";
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Net::LDAP;
use oss_utils;

my $entry;

# Get Admin Password
my $ldappw = `/usr/sbin/get_admin_pw`;
# Get ldap base
my $ldapbase = `sed '/#/d' /etc/openldap/ldap.conf | gawk '/base|BASE/ {print \$2}'`;

system("sed -i 's/index serviceAccesControl sub/index role,serviceAccesControl sub/' /etc/openldap/slapd.conf");
# Make LDAP Connection
my $LDAP = Net::LDAP->new('localhost',port =>389 ,version => 3);
$LDAP->bind('cn=Administrator,'.$ldapbase, password=>$ldappw);


my $mesg = $LDAP->search( base   => 'ou=sysconfig,'.$ldapbase,
                          filter => "(objectClass=SchoolConfiguration)",
		         scope   => 'one'
		     );
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
my $date = "$year-$mon-$mday.$hour-$min";
system("cp /etc/sysconfig/schoolserver /var/adm/backup/schoolserver.$date");

my $sysconfig = "########################################################################
## Path:           Network/Server
## Description:    Basic Configuration of the Open School Server
########################################################################

";

my $sections = {};

foreach $entry ( $mesg->entries )
{
  my @path    = split /\//, $entry->get_value('configurationPath');
  my $sec     = $path[2];
  my $key     = $entry->get_value('configurationKey');
  my $value   = $entry->get_value('configurationValue') || '';
  my $type    = $entry->get_value('configurationValueType') || 'string';
  my $des     = $entry->get_value('description');
  my $ro      = $entry->get_value('configurationValueRO');
  my $default = $entry->get_value('configurationDefaultValue') || '';
  my $values  = join ',',$entry->get_value('configurationAvailableValue') || '';
  if ( $values ne '' )
  {
    $values = '('.$values.')';
  }
  my $config  = "";
  if ( $ro eq "yes" )
  {
    $config  = "## Type:	$type".$values." readonly
## Default:	$default
";
  }
  else
  {
    $config  = "## Type:	$type".$values."
## Default:	$default
";
  }
  if( defined $des )
  {
    $config .= "# $des\n";
  }  
  $config .= "$key=\"$value\"\n";

  $sections->{$sec}->{$key} = $config;

}

foreach my $sec (sort keys %$sections)
{
  $sysconfig .= "########################################################################
## Path:        Network/Server/$sec
## Description: Configuration of the Open School Server: $sec
########################################################################

";

  foreach my $key (sort(keys %{$sections->{$sec}}))
  {
    $sysconfig .=  $sections->{$sec}->{$key}."\n";   
  }
}

write_file('/etc/sysconfig/schoolserver',$sysconfig);
