#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Net::LDAP;
use Net::LDAP::Entry;
use oss;
use oss_utils;

my $plugin     = '';
my $oid        = '';
my $uid        = '';
my $fquota     = '';
my $fsystem    = '';
my $quota      = '';
my $filter     = '';
my @dns        = ();
my @changes    = ();
my %SYSCONFIG  = ();
my $DEBUG      = 0;
#Now we make LDAP connections
my $oss = oss->new();
if( $oss->connect_ldap('admin') ne 1 ) {
  die $oss->{ERROR}->{text};
}
$oss->init_sysconfig('file');

if( $oss->get_school_config('SCHOOL_DEBUG') eq 'yes' )
{
  $DEBUG = 1;
}

open(OUT,">/tmp/modify_school") if($DEBUG);
while(<STDIN>){
   print OUT if($DEBUG);

   # Clean up the line!
   chomp; s/^\s+//; s/\s+$//;

   my ( $key, $value ) = split / /,$_,2;
   # The plugins have to get the original lines but not the empty lines
   if( $key ne '' )
   {
        $plugin .= $_."\n";
   }
   if( !defined $value  || $value eq  '' )
   {
      $key;
      if( $key =~ /^uniqueIdentifier=.*/i)
      {
        push @dns, $key;
      }
   }
   else
   {
      my ($attr, $val) = split / /,$value,2;
      if($attr eq 'webspace'  )
      {
        #TODO implement it!
      }
      elsif($attr eq 'adminpassword'  )
      {
        #TODO implement it!
      }
      elsif($attr =~ /^SCHOOL_/  )
      {
         $SYSCONFIG{$attr} = $val if( $key eq 'add' );
      }
      else
      {
          if( defined $val )
	  {
            push @changes, "$key" => [ "$attr" => [ "$val" ]];
          }
	  else
	  {
            push @changes, "$key" => [ "$attr" => []];
          }
      }
   }
}
close OUT if($DEBUG);
foreach my $dn ( @dns )
{
    if( -1 < $#changes )
    {
      my $mesg = $oss->{LDAP}->modify( $dn, changes=>\@changes );
      if( $mesg->code != 0 )
      {
        $oss->ldap_error($mesg);
        print STDERR $oss->{ERROR}->{text};
      }
    }
    #TODO SYSCONFIG ÄNDERUNGEN
    print $oss->reply($oss->get_school($dn));
}
#Starting the plugins
my $TMPFILE = write_tmp_file($plugin);
system("/usr/share/oss/plugins/plugin_handler.sh modify_school $TMPFILE");

$oss->destroy();

