#!/usr/bin/perl  -w
BEGIN{
    push @INC,"/srv/www/admin/lib"
}

use strict;
use Utils;
use Net::LDAP;
use Net::LDAP::Entry;

my $start = shift;
my $end   = shift;
my $int   = shift;

if( ! $int )
{
  print "
usage: oss_repair_ox_accounts.pl OXDayviewStartTime OXDayviewEndTime OXDayviewInterval

EXAMPLE

oss_repair_ox_accounts.pl 00:30 22:30 10

";

exit 0;

}
# Get Admin Password
my $ldappw = `/usr/sbin/get_admin_pw`;
# Get ldap base
my $ldapbase = `sed '/#/d' /etc/openldap/ldap.conf | gawk '/base|BASE/ {print \$2}'`;


# Make LDAP Connection
my $LDAP = Net::LDAP->new('localhost',port =>389 ,version => 3);
$LDAP->bind('cn=Administrator,'.$ldapbase, password=>$ldappw);


my $mesg = $LDAP->search( base   => "ou=people,$ldapbase",
                       filter => "(objectclass=OXUserObject)",
		       scope  => 'one',
		     );

foreach my $entry ( $mesg->entries ) {
     if( $entry->exists('OXDayviewStartTime') )
     {
        $entry->replace( OXDayviewStartTime => $start )
     }
     else
     {
        $entry->add( OXDayviewStartTime => $start )
     }
     if( $entry->exists('OXDayviewEndTime') )
     {
        $entry->replace( OXDayviewEndTime => $end )
     }
     else
     {
        $entry->add( OXDayviewEndTime => $end )
     }
     if( $entry->exists('OXDayviewInterval') )
     {
        $entry->replace( OXDayviewInterval => $int )
     }
     else
     {
        $entry->add( OXDayviewInterval => $int )
     }
     $entry->update( $LDAP );
     print $entry->dn()." corrected\n";
}
