#!/usr/bin/perl
# Copyright (c) 2005 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>

BEGIN{
    push @INC,"/srv/www/admin/lib";
}

$| = 1; # do not buffer stdout

use strict;
use Net::LDAP;
use Utils;

my ($base, $host, $port) = parse_file("/etc/openldap/ldap.conf", "BASE", "HOST", "PORT");
if(!$host)
{
 $host = 'ldap';
}
if(!$port)
{
 $port = '389';
}
my $ldap =  Net::LDAP->new($host, port => $port , version => 3);

my $result = $ldap->search(
                base   => 'ou=group,'.$base,
                filter => '(&(objectclass=schoolPrimaryGroup)(!(gidnumber=503)))',
		scope  => 'one',
                attr   => ['gidnumber']
        );

my @APPS    = split /,/,read_rcconfig("SCHOOL_EGW_APPLICATIONS");
my @ST_APPS = split /,/,read_rcconfig("SCHOOL_EGW_STUDENT_APPLICATIONS");

my $mysql = '';
foreach my $entry ($result->all_entries) {
	#default applications
	my $gid = $entry->get_value('gidnumber');

	system("ssh mailserver echo \"\\\"delete from egw_acl where acl_appname!=\'phpgw_group\' AND acl_location=\'run\' AND acl_account=$gid\\\"\" | mysql egroupware");
	if( $gid eq 501 )
	 {
		foreach my $app (@ST_APPS)
		{
			$mysql = "ssh mailserver echo ".'"\"INSERT INTO egw_acl VALUES (\''.$app."','run',".$gid.',1);\"" | mysql egroupware';
			system ($mysql);
		}
	}
	else
	{
		foreach my $app (@APPS)
		{
			$mysql = "ssh mailserver echo ".'"\"INSERT INTO egw_acl VALUES (\''.$app."','run',".$gid.',1);\"" | mysql egroupware';
			system ($mysql);
		}
	}
}
