#!/usr/bin/perl
# Copyright (c) 2005 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>

BEGIN{
    push @INC,"/srv/www/admin/lib";
}

$| = 1; # do not buffer stdout

use strict;
use Net::LDAP;
use Utils;

my ($base, $host, $port) = parse_file("/etc/openldap/ldap.conf", "BASE", "HOST", "PORT");
if(!$host)
{
 $host = 'ldap';
}
if(!$port)
{
 $port = '389';
}
my $ldap =  Net::LDAP->new($host, port => $port , version => 3);
open(MYSQL,">/tmp/mysql");

my $cn = shift;
my $filter = '(objectclass=schoolGroup)';

if( $cn ) {
	$filter = "(cn=$cn)";
}
my $result = $ldap->search(
                base   => 'ou=group,'.$base,
                filter => $filter,
		scope  => 'one',
                attr   => ['gidnumber']
        );

if( $cn )
{
	my $gid   = $result->entry(0)->get_value('gidNumber');
	print MYSQL "INSERT INTO egw_acl VALUES ('calendar','run',$gid,1);\n";
}
else
{
	print MYSQL "delete from egw_acl where acl_appname='calendar' AND acl_location='run';\n";
	foreach my $entry ($result->all_entries)
	{
		my $gid = $entry->get_value('gidnumber');
		print MYSQL"INSERT INTO egw_acl VALUES ('calendar','run','-$gid',1);\n";
	}
}
close MYSQL;
system("mysql egroupware < /tmp/mysql");
system("rm /tmp/mysql");

