#!/usr/bin/perl
# Copyright (c) 2005 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>

BEGIN{
    push @INC,"/srv/www/admin/lib";
}

$| = 1; # do not buffer stdout

use strict;
use Net::LDAP;
use Utils;

my ($base, $host, $port) = parse_file("/etc/openldap/ldap.conf", "BASE", "HOST", "PORT");
if(!$host)
{
 $host = 'ldap';
}
if(!$port)
{
 $port = '389';
}
my $ldap =  Net::LDAP->new($host, port => $port , version => 3);
open(MYSQL,">/tmp/mysql");

my $user   = shift;
my $cn     = shift;
my $filter = '(&(!(uid=admin))(objectclass=SchoolAccount))';
if ( $user )
{
	$filter = "(uid=$user)";
}
my $result = $ldap->search(
                base   => 'ou=people,'.$base,
                filter => $filter,
		scope  => 'one',
                attr   => ['uidNumber','OXGroupID']
        );

if ( $user && $cn )
{
	my $uidNumber = $result->entry(0)->get_value('uidNumber');
	$result = $ldap->search(
	             base   => 'ou=group,'.$base,
	             filter => "cn=$cn",
	     	scope  => 'one',
	             attr   => ['gidNumber']
	     );
	my $gidNumber = $result->entry(0)->get_value('gidNumber');
	
	print MYSQL "INSERT INTO egw_acl VALUES ('phpgw_group','-$gidNumber',$uidNumber,1);\n";
	close(MYSQL);
	system("mysql egroupware < /tmp/mysql");
	system("rm /tmp/mysql");
}

foreach my $entry ($result->all_entries)
{
	my $uidNumber = $entry->get_value('uidNumber');
	print MYSQL "delete from egw_acl where acl_appname='phpgw_group' AND acl_account=$uidNumber;\n";
	foreach my $gid ($entry->get_value('OXGroupID'))
	{
		print MYSQL "INSERT INTO egw_acl VALUES ('phpgw_group','-$gid',$uidNumber,1);\n";
	}
}
close(MYSQL);
system("mysql egroupware < /tmp/mysql");
system("rm /tmp/mysql");
