#!/usr/bin/perl
# Copyright (c) 2005 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>

BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

$| = 1; # do not buffer stdout

use strict;
use oss_utils;
use oss;
use DBI;

my $oss  = oss->new();
my $uid  = "";
my $role = "";
my $LANG = "EN";
my $mpw  = `gawk 'FS="="{ if(/password/) print \$2 }' /root/.my.cnf`;
chomp $mpw;

while(<STDIN>)
{
  my ( $key, $value ) = split / /,$_,2;
  chomp $value;
  if ( $key eq 'uid' )
  {
    $uid = $value;
  }
  if ( $key eq 'role' )
  {
     $role = $value;
  }
  if ( $key eq 'preferredlanguage' )
  {
     $LANG = $value;
  }
}

if ( $role eq 'workstations' )
{
  exit;
}
if( ! $oss->connect_ldap() )
{ 
  print $oss->{ERROR}->{text};
  exit 1;
}
my $USE_EGROUPWARE = $oss->get_school_config("SCHOOL_USE_EGROUPWARE");
if( $USE_EGROUPWARE =~ /^yes$/i )
{
	my $result = $oss->{LDAP}->search(
			base   => $oss->{LDAP_BASE},
			filter => "(uid=$uid)",
			scope  => 'sub',
			attr   => ['uidNumber','OXGroupID']
		);


	my $entry = $result->shift_entry;
	my $uidNumber = $entry->get_value('uidNumber');
        my $dbh = DBI->connect( 'dbi:mysql:egroupware', 'root', $mpw);
	foreach my $gid ($entry->get_value('OXGroupID'))
	{
	    $dbh->do("INSERT INTO egw_acl VALUES ('phpgw_group','-$gid',$uidNumber,1)");
	}
	$dbh->disconnect;
}
my $USE_OX = $oss->get_school_config("SCHOOL_USE_OX");
if( $USE_OX =~ /^yes$/i )
{
  system("ssh mailserver /var/www/html/openxchange/sbin/addusersql_ox --username=$uid --lang=$LANG &> /dev/null");
}
