#!/usr/bin/perl
# Copyright (c) 2005 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>

BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

$| = 1; # do not buffer stdout

use strict;
use oss_utils;
use oss;
use DBI;

my $oss       = oss->new();
my $uid       = "";
my $uidnumber = "";
my $mpw  = `gawk 'FS="="{ if(/password/) print \$2 }' /root/.my.cnf`;
chomp $mpw;

while(<STDIN>)
{
  my ( $key, $value ) = split / /,$_,2;
  chomp $value;
  if ( $key eq 'uid' )
    $uid = $value;
  }
  elsif( $key eq 'uidnumber' )
  {
    $uidnumber = $value;
  }

}

if( ! $oss->connect_ldap() )
{ 
  print $oss->{ERROR}->{text};
  exit 1;
}
my $USE_EGROUPWARE = $oss->get_school_config("SCHOOL_USE_EGROUPWARE");
if( $USE_EGROUPWARE =~ /^yes$/i )
{
	#TODO we have to delete other tables too
        my $dbh = DBI->connect( 'dbi:mysql:egroupware', 'root', $mpw);
	$dbh->do("DELETE FROM egw_acl where acl_account=$uidnumber");
	$dbh->disconnect;
}
my $USE_OX = $oss->get_school_config("SCHOOL_USE_OX");
if( $USE_OX =~ /^yes$/i )
{
  system("ssh mailserver /var/www/html/openxchange/sbin/addusersql_ox --username=$uid --lang=$LANG &> /dev/null");
}
