#!/usr/bin/suidperl  -U
# Copyright (c) 2006 Peter Varkoly Fuerth, Germany.  All rights reserved
# <peter@varkoly.de>
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}
$| = 1; # do not buffer stdout

use strict;
use Net::LDAP;
use oss;


# Open an LDAP connection
my $oss = oss->new();
if( $oss->connect_ldap('admin') ne 1 )
{
  die $oss->{ERROR}->{text};
}


my $DEBUG               = 0;
if( $oss->get_school_config('SCHOOL_DEBUG') eq 'yes' )
{
  $DEBUG = 1;
}
open(LOG,">/var/log/squid/$$.log") if ($DEBUG);

while(<>)
{
  chomp;
  my $ip   = `host $_ | gawk '{print \$4}'`;
  chomp    $ip;
  if( $ip eq "pointer" )
  {
    $ip = $_;
  }
  my $user =`smbstatus -b | grep -m 1 $ip | gawk '{ print \$2 }'`;
  chomp $user;
  print LOG "$_:$ip:$user\n" if ($DEBUG);
  my $result = $oss->{LDAP}->search( base   => 'ou=people,'.$oss->{LDAP_BASE},
		              filter => "(uid=$user)",
		              scope  => 'one',
		              attr   => ['internetDisabled']
	      );
  if( $result->count() eq 0 )
  {
    print "ERR user=\"$user\" No such user\n"; 
    next;
  }
  if( defined $result->entry(0)->get_value('internetDisabled') &&
              $result->entry(0)->get_value('internetDisabled') eq 'yes' )
  {
    print "ERR user=\"$user\" is not allowed to surf\n"; 
    next;
  }
  print "OK user=\"$user\"\n"; 
}
$oss->destroy();
close(LOG) if ($DEBUG);
