#!/usr/bin/perl  -w
BEGIN{
    push @INC,"/srv/www/admin/lib"
}

use strict;
use Data::Dumper;
use Net::IMAP;
use IMAPUtils;
use Utils;
use Net::LDAP;

my $rooms = shift;
if( !$rooms)
{
   print "Usage: add_room.pl <nr_romms>\n";
   exit;
}
# Get Admin Password
my $ldappw = `/usr/sbin/oss_get_admin_pw`;
# Get ldap base
my $ldapbase = `sed '/#/d' /etc/openldap/ldap.conf | gawk '/base|BASE/ {print \$2}'`;

# Make LDAP Connection
my $LDAP = Net::LDAP->new('localhost',port =>389 ,version => 3);
$LDAP->bind('cn=Administrator,'.$ldapbase, password=>$ldappw);

# Get hostname
my $host = `hostname -s`;
chomp $host;

# Read some values from rcconfig
my $netmask      = read_rcconfig("SCHOOL_NETMASK");
my $network      = read_rcconfig("SCHOOL_NETWORK");
my $first_net    = read_rcconfig("SCHOOL_FIRST_ROOM_NET");
my $room_nr      = read_rcconfig("SCHOOL_ROOM_NR");
$rooms += $room_nr;
$netmask   =~ /(\d+)\.(\d+).(\d+).(\d+)/;
my $duesseldorf = 0;
if( $3 eq '255' )
{
   $duesseldorf = 1;
}

$first_net =~ /(\d+)\.(\d+).(\d+).(\d+)/;

my $A  = $1;
my $B  = $2;
my $C  = $3;
my $D  = $4;
if($duesseldorf)
{
  $B += int($room_nr/4);
}
else
{
  $C += int($room_nr/4);
}
$D += ($room_nr%4) * 64;

print "First new Room Network: $A.$B.$C.$D\n";
for (my $i=$room_nr; $i < $rooms; $i++)
{
  print "Room$i: $A.$B.$C.$D\n"; 
  $LDAP->add( dn => "cn=Room$i,cn=$network,cn=config1,cn=$host,ou=DHCP,$ldapbase",
            attr => [
	    		objectClass => [ 'top','dhcpOptions','dhcpGroup','SchoolRoom' ],
			cn          => "Room$i",
			dhcpNetMask => 26,
			dhcpRange   => "$A.$B.$C.$D"
	            ]
		);
      $D = $D + 64;
      if( $D > 255)
      {
         $D = 0;
         if($duesseldorf)
	 {
	   $B += 1;
           if( $B > 255 )
	   {
	      print "Not enough network space for $rooms.\n";
	      print "You have $i rooms actually.\n";
	      $rooms = $i;
	      last;
           }
	 }
	 else
	 {
           $C += 1;
           if( $C > 255 )
	   {
             $C = 0;
             $B += 1;
           }
	 }
      }
}
$LDAP->modify( "configurationKey=SCHOOL_ROOM_NR,ou=sysconfig,$ldapbase",
                replace => { configurationValue => $rooms }
		             );
$LDAP->unbind;

system("sed -i 's/^SCHOOL_ROOM_NR=.*/SCHOOL_ROOM_NR=\"$rooms\"/' /etc/sysconfig/schoolserver");
