#!/usr/bin/perl
BEGIN{
    push @INC,"/usr/share/oss/lib/";
}

use strict;
use Net::LDAP;
use Net::LDAP::Entry;
use oss;
use oss_utils;
use Net::Netmask;
# Make LDAP Connection
my $oss = oss->new();
if( $oss->connect_ldap('admin') ne 1 ) {
  die $oss->{ERROR}->{text};
}

my $mesg = $oss->{LDAP}->search( base   => "ou=DHCP,".$oss->{LDAP_BASE} ,
                                 filter => "(&(description=*)(objectclass=SchoolRoom))"
                                );
foreach my $entry ( $mesg->entries )
{
    my $sip   = $entry->get_value('dhcpRange');
    my $mask  = $entry->get_value('dhcpNetMask');
    my $desc  = $entry->get_value('description');
    my $block = new Net::Netmask($sip.'/'.$mask);
    $sip =~ /(\d+\.\d+\.\d+)\.(\d+)/;
    my $last  = $2 + $block->size() -1;
    my $TMP   = 'iprange '.$sip.'-'."$1.$last\ndescription $desc\n";
    my $TMPFILE = write_tmp_file($TMP);
    system("cat $TMPFILE; echo;");
    system("sudo /usr/share/oss/plugins/plugin_handler.sh add_room $TMPFILE");
}

